from pydantic import BaseModel


class PDBScanTestProperties(BaseModel):
    ANALYSIS_VERSION: str = "-999"
    YARR_VERSION: str = "-999"
    MEASUREMENT_DATE: str = "0000-00-00T00:00:00"
    MEASUREMENT_DURATION: str = "0h0min"
    MEASUREMENT_VERSION: str = "-999"


class PDBMinimumHealthTestFrontEndResults(BaseModel):
    MIN_HEALTH_DEAD_DIGITAL: int = -999
    MIN_HEALTH_BAD_DIGITAL: int = -999
    MIN_HEALTH_DEAD_ANALOG: int = -999
    MIN_HEALTH_BAD_ANALOG: int = -999
    MIN_HEALTH_THRESHOLD_MEAN: str = "-999.99"
    MIN_HEALTH_THRESHOLD_SIGMA: str = "-999.99"
    MIN_HEALTH_THRESHOLD_FAILED_FITS: int = -999
    MIN_HEALTH_HIGH_ENC: int = -999
    MIN_HEALTH_NOISE_MEAN: str = "-999.99"
    MIN_HEALTH_NOISE_SIGMA: str = "-999.99" 
    MIN_HEALTH_TOT_MEAN: str = "-999.99"
    MIN_HEALTH_TOT_SIGMA: str = "-999.99"
    MIN_HEALTH_THRESHOLD_FAILED_FITS_INDEPENDENT: int = -999
    MIN_HEALTH_HIGH_ENC_INDEPENDENT: int = -999
    MIN_HEALTH_COLUMN_DISABLED: int = -999


class PDBMinimumHealthTestFrontEndReport(BaseModel):
    component: str = "ITkPix"
    testType: str = "MIN_HEALTH_TEST"
    institution: str = "Nowhere"
    runNumber: str = "000000"
    date: str = "0000-00-00T00:00:00"
    passed: bool = False
    problems: bool = False
    properties: PDBScanTestProperties


pfa_pdb_report = {
  "component": "ITkPix",
  "testType": "PIXEL_FAILURE_ANALYSIS",
  "institution": "Nowhere",
  "runNumber": "000000",
  "date": "0000-00-00T00:00:00",
  "passed": "true",
  "problems": "none",
  "properties": {
    "ANALYSIS_VERSION": "-999",
    "YARR_VERSION": "-999",
    "MEASUREMENT_DURATION": "0h0min",
    "MEASUREMENT_DATE": "0000-00-00T00:00:00",
    "MEASUREMENT_VERSION": "-999"
  },
  "results": {
    "PIXEL_FAILURE_DEAD_DIGITAL": 0,
    "PIXEL_FAILURE_BAD_DIGITAL": 0,
    "PIXEL_FAILURE_DEAD_ANALOG": 0,
    "PIXEL_FAILURE_BAD_ANALOG": 0,
    "PIXEL_FAILURE_TUNING_BAD": 0,
    "PIXEL_FAILURE_HIGH_ENC": 0,
    "PIXEL_FAILURE_ELECTRICALLY_FAILED": 0,
    "PIXEL_FAILURE_MERGED_BUMPS": 0,
    "PIXEL_FAILURE_HIGH_NOISE": 0,
    "PIXEL_FAILURE_SOURCE_SCAN_DONE": True,
    "PIXEL_FAILURE_DISCONNECTED_BUMPS_SOURCE_SCAN": 0,
    "PIXEL_FAILURE_DISCONNECTED_BUMPS_ZERO_BIAS_SCAN": 0,
    "PIXEL_FAILURE_DISCONNECTED_BUMPS_XTALK_SCAN": 0,
    "PIXEL_FAILURE_DISCONNECTED_PIXELS": 0,
    "PIXEL_FAILURE_DISC_PIXEL_ALL_ELEC": -1,
    "PIXEL_FAILURE_FAILING_PIXELS": 0,
    "PIXEL_FAILURE_COLUMN_DISABLED": -1
  }
}

module_e_summary = {
  "component": "00000000",
  "testType": "E_SUMMARY",
  "institution": "",
  "runNumber": "00000000",
  "date": "0000-00-00T00:00:00",
  "passed": "true",
  "problems": "none",
  "properties": {
    "MODULE_TEMPERATURE": "-99.9",
    "ANALYSIS_VERSION": "00v0",
    "MEASUREMENT_DATE": "0000-00-00T00:00:00"
  },
  "results": {
    "MODULE_ADC_CALIBRATION": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_1": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_2": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_3": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_4": None,
    "MODULE_SLDO": None,
    "MODULE_SLDO_FE_LINK_1": None,
    "MODULE_SLDO_FE_LINK_2": None,
    "MODULE_SLDO_FE_LINK_3": None,
    "MODULE_SLDO_FE_LINK_4": None,
    "MODULE_VCAL_CALIBRATION": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_1": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_2": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_3": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_4": None,
    "MODULE_ANALOG_READBACK": None,
    "MODULE_ANALOG_READBACK_FE_LINK_1": None,
    "MODULE_ANALOG_READBACK_FE_LINK_2": None,
    "MODULE_ANALOG_READBACK_FE_LINK_3": None,
    "MODULE_ANALOG_READBACK_FE_LINK_4": None,
    "MODULE_LP_MODE": None,
    "MODULE_LP_MODE_FE_LINK_1": None,
    "MODULE_LP_MODE_FE_LINK_2": None,
    "MODULE_LP_MODE_FE_LINK_3": None,
    "MODULE_LP_MODE_FE_LINK_4": None,
    "MODULE_OVERVOLTAGE_PROTECTION": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_1": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_2": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_3": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_4": None,
    "MODULE_INJECTION_CAPACITANCE": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_1": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_2": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_3": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_4": None,
    "MODULE_MIN_HEALTH_TEST": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_1": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_2": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_3": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_4": None,
    "MODULE_TUNING": None,
    "MODULE_TUNING_FE_LINK_1": None,
    "MODULE_TUNING_FE_LINK_2": None,
    "MODULE_TUNING_FE_LINK_3": None,
    "MODULE_TUNING_FE_LINK_4": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_1": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_2": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_3": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_4": None,
    "MODULE_BAD_PIXEL_NUMBER": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER": -1,
    "MODULE_DISABLED_COLUMNS_NUMBER": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_1": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_2": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_3": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_4": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_1": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_2": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_3": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_4": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_1": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_2": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_3": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_4": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_1": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_2": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_3": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_4": -1,
    "MODULE_UNDERSHUNT_PROTECTION": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_1": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_2": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_3": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_4": None,
    "MODULE_DATA_TRANSMISSION": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_1": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_2": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_3": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_4": None
  }
}


mht_pdb_original = {
  "component": "...",
  "testType": "MIN_HEALTH_TEST",
  "institution": "...",
  "runNumber": "...",
  "date": "2025-02-06T12:47:02.320Z",
  "passed": True,
  "problems": False,
  "properties": {
    "ANALYSIS_VERSION": None,
    "YARR_VERSION": None,
    "MEASUREMENT_DATE": None,
    "MEASUREMENT_DURATION": None,
    "MEASUREMENT_VERSION": None
  },
  "results": {
    "MIN_HEALTH_DEAD_DIGITAL": 0,
    "MIN_HEALTH_BAD_DIGITAL": 0,
    "MIN_HEALTH_DEAD_ANALOG": 0,
    "MIN_HEALTH_BAD_ANALOG": 0,
    "MIN_HEALTH_THRESHOLD_MEAN": 0,
    "MIN_HEALTH_THRESHOLD_SIGMA": 0,
    "MIN_HEALTH_THRESHOLD_FAILED_FITS": 0,
    "MIN_HEALTH_HIGH_ENC": 0,
    "MIN_HEALTH_NOISE_MEAN": 0,
    "MIN_HEALTH_NOISE_SIGMA": 0,
    "MIN_HEALTH_TOT_MEAN": 0,
    "MIN_HEALTH_TOT_SIGMA": 0,
    "MIN_HEALTH_THRESHOLD_FAILED_FITS_INDEPENDENT": 0,
    "MIN_HEALTH_HIGH_ENC_INDEPENDENT": 0,
    "MIN_HEALTH_COLUMN_DISABLED": -1
  }
}


pfa_pdb_original = {
  "component": "...",
  "testType": "PIXEL_FAILURE_ANALYSIS",
  "institution": "...",
  "runNumber": "...",
  "date": "2025-02-06T12:49:14.023Z",
  "passed": True,
  "problems": False,
  "properties": {
    "ANALYSIS_VERSION": None,
    "YARR_VERSION": None,
    "MEASUREMENT_DURATION": None,
    "MEASUREMENT_DATE": None,
    "MEASUREMENT_VERSION": None
  },
  "results": {
    "PIXEL_FAILURE_DEAD_DIGITAL": 0,
    "PIXEL_FAILURE_BAD_DIGITAL": 0,
    "PIXEL_FAILURE_DEAD_ANALOG": 0,
    "PIXEL_FAILURE_BAD_ANALOG": 0,
    "PIXEL_FAILURE_TUNING_BAD": 0,
    "PIXEL_FAILURE_HIGH_ENC": 0,
    "PIXEL_FAILURE_ELECTRICALLY_FAILED": 0,
    "PIXEL_FAILURE_MERGED_BUMPS": 0,
    "PIXEL_FAILURE_HIGH_NOISE": 0,
    "PIXEL_FAILURE_SOURCE_SCAN_DONE": True,
    "PIXEL_FAILURE_DISCONNECTED_BUMPS_SOURCE_SCAN": 0,
    "PIXEL_FAILURE_DISCONNECTED_BUMPS_ZERO_BIAS_SCAN": 0,
    "PIXEL_FAILURE_DISCONNECTED_BUMPS_XTALK_SCAN": 0,
    "PIXEL_FAILURE_DISCONNECTED_PIXELS": 0,
    "PIXEL_FAILURE_DISC_PIXEL_ALL_ELEC": -1,
    "PIXEL_FAILURE_FAILING_PIXELS": 0,
    "PIXEL_FAILURE_COLUMN_DISABLED": -1
  }
}

module_e_summary_orig = {
  "component": "...",
  "testType": "E_SUMMARY",
  "institution": "...",
  "runNumber": "...",
  "date": "2025-02-06T13:14:12.395Z",
  "passed": True,
  "problems": False,
  "properties": {
    "MODULE_TEMPERATURE": None,
    "ANALYSIS_VERSION": None,
    "MEASUREMENT_DATE": None
  },
  "results": {
    "MODULE_ADC_CALIBRATION": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_1": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_2": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_3": None,
    "MODULE_ADC_CALIBRATION_FE_LINK_4": None,
    "MODULE_SLDO": None,
    "MODULE_SLDO_FE_LINK_1": None,
    "MODULE_SLDO_FE_LINK_2": None,
    "MODULE_SLDO_FE_LINK_3": None,
    "MODULE_SLDO_FE_LINK_4": None,
    "MODULE_VCAL_CALIBRATION": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_1": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_2": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_3": None,
    "MODULE_VCAL_CALIBRATION_FE_LINK_4": None,
    "MODULE_ANALOG_READBACK": None,
    "MODULE_ANALOG_READBACK_FE_LINK_1": None,
    "MODULE_ANALOG_READBACK_FE_LINK_2": None,
    "MODULE_ANALOG_READBACK_FE_LINK_3": None,
    "MODULE_ANALOG_READBACK_FE_LINK_4": None,
    "MODULE_LP_MODE": None,
    "MODULE_LP_MODE_FE_LINK_1": None,
    "MODULE_LP_MODE_FE_LINK_2": None,
    "MODULE_LP_MODE_FE_LINK_3": None,
    "MODULE_LP_MODE_FE_LINK_4": None,
    "MODULE_OVERVOLTAGE_PROTECTION": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_1": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_2": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_3": None,
    "MODULE_OVERVOLTAGE_PROTECTION_FE_LINK_4": None,
    "MODULE_INJECTION_CAPACITANCE": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_1": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_2": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_3": None,
    "MODULE_INJECTION_CAPACITANCE_FE_LINK_4": None,
    "MODULE_MIN_HEALTH_TEST": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_1": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_2": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_3": None,
    "MODULE_MIN_HEALTH_TEST_FE_LINK_4": None,
    "MODULE_TUNING": None,
    "MODULE_TUNING_FE_LINK_1": None,
    "MODULE_TUNING_FE_LINK_2": None,
    "MODULE_TUNING_FE_LINK_3": None,
    "MODULE_TUNING_FE_LINK_4": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_1": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_2": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_3": None,
    "MODULE_PIXEL_FAILURE_ANALYSIS_FE_LINK_4": None,
    "MODULE_BAD_PIXEL_NUMBER": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER": -1,
    "MODULE_DISABLED_COLUMNS_NUMBER": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_1": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_2": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_3": -1,
    "MODULE_BAD_PIXEL_NUMBER_FE_4": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_1": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_2": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_3": -1,
    "MODULE_HIGHEST_NUMBER_BAD_PIXELS_CLUSTER_FE_4": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_1": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_2": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_3": -1,
    "MODULE_ELECTRICALLY_BAD_PIXEL_NUMBER_FE_4": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_1": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_2": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_3": -1,
    "MODULE_DISCONNECTED_PIXEL_NUMBER_FE_4": -1,
    "MODULE_UNDERSHUNT_PROTECTION": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_1": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_2": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_3": None,
    "MODULE_UNDERSHUNT_PROTECTION_FE_LINK_4": None,
    "MODULE_DATA_TRANSMISSION": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_1": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_2": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_3": None,
    "MODULE_DATA_TRANSMISSION_FE_LINK_4": None
  }
}